 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
@Version 29.04.2014
*/ 

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;
import javax.swing.border.LineBorder;

public class SkispringenGUI extends JFrame {

	private static final int VOR_WETTBEWERB = 0;
	private static final int REIHENFOLGE_NACH_DURCHGANG_1 = 1;
	private static final int AUSSORTIEREN_DER_SCHLECHTESTEN = 2;
	private static final int STARTREIHENFOLGE_VOR_DURCHGANG_2 = 3;
	private static final int ENDPLATZIERUNG_NACH_DURCHGANG_2 = 4;

	private int phase;

	private Simulation dieSimulation;

	private JPanel contentPane;

	private JLabel lblSkispringen;

	private JSeparator separator;

	private JButton btnNewCompetition;

	private JTextArea anzeige;

	private JScrollPane sp;
	private JButton btnNchsterSchritt;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					SkispringenGUI frame = new SkispringenGUI();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public SkispringenGUI() {

		setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 480, 518);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);

		lblSkispringen = new JLabel("Skispringen");
		lblSkispringen.setHorizontalAlignment(SwingConstants.CENTER);
		lblSkispringen.setFont(new Font("Tahoma", Font.PLAIN, 18));
		lblSkispringen.setBounds(10, 11, 452, 22);
		contentPane.add(lblSkispringen);

		separator = new JSeparator();
		separator.setBounds(10, 44, 452, 2);
		contentPane.add(separator);

		JButton btnNewCompetition = new JButton("New Competition");
		btnNewCompetition.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				startOver();
			}
		});
		btnNewCompetition.setBounds(10, 57, 290, 23);
		contentPane.add(btnNewCompetition);

		anzeige = new JTextArea();
		anzeige.setBackground(UIManager.getColor("Button.background"));
		anzeige.setBorder(new LineBorder(new Color(0, 0, 0)));

		sp = new JScrollPane(anzeige);
		sp.setBounds(10, 91, 290, 389);
		contentPane.add(sp);

		btnNchsterSchritt = new JButton("N\u00E4chster Schritt");
		btnNchsterSchritt.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				nextPhase();
			}
		});
		btnNchsterSchritt.setBounds(307, 93, 155, 23);
		btnNchsterSchritt.setEnabled(false);
		contentPane.add(btnNchsterSchritt);

	}

	private void startOver() {
		JTextField anzahlTeilnehmer = new JTextField();
		anzahlTeilnehmer.setText("10");
		JTextField anzahlImZweitenDurchgang = new JTextField();
		anzahlImZweitenDurchgang.setText("5");
		Object[] message = { "Anzahl der Teilnehmer im ersten Durchgang",
				anzahlTeilnehmer, "Anzahl der Teilnehmer im zweiten Durchgang",
				anzahlImZweitenDurchgang };

		JOptionPane pane = new JOptionPane(message, JOptionPane.PLAIN_MESSAGE,
				JOptionPane.OK_CANCEL_OPTION);
		pane.createDialog(this, "Neuen Wettbewerb starten").setVisible(true);
		if (pane.getValue() != null
				&& (int) pane.getValue() == JOptionPane.OK_OPTION) {
			String at1 = anzahlTeilnehmer.getText();
			String at2 = anzahlImZweitenDurchgang.getText();

			int at1_zahl = Integer.parseInt(at1);
			int at2_zahl = Integer.parseInt(at2);

			this.dieSimulation = new Simulation(at1_zahl, at2_zahl);
			this.phase = SkispringenGUI.VOR_WETTBEWERB;
			this.btnNchsterSchritt.setEnabled(true);

			showActual();
		} else {
			this.phase = SkispringenGUI.VOR_WETTBEWERB;
		}
	}

	private void nextPhase() {
		switch (this.phase) {
		case SkispringenGUI.VOR_WETTBEWERB:
			this.dieSimulation.ersterDurchgang();
			phase = SkispringenGUI.REIHENFOLGE_NACH_DURCHGANG_1;
			showActual();
			break;
		case SkispringenGUI.REIHENFOLGE_NACH_DURCHGANG_1:
			this.dieSimulation.erstenDurchgangNachbereiten();
			phase = SkispringenGUI.AUSSORTIEREN_DER_SCHLECHTESTEN;
			showActual();
			break;
		case SkispringenGUI.AUSSORTIEREN_DER_SCHLECHTESTEN:
			this.dieSimulation.zweitenDurchgangVorbereiten();
			phase = SkispringenGUI.STARTREIHENFOLGE_VOR_DURCHGANG_2;
			showActual();
			break;
		case SkispringenGUI.STARTREIHENFOLGE_VOR_DURCHGANG_2:
			this.dieSimulation.zweiterDurchgang();
			phase = SkispringenGUI.ENDPLATZIERUNG_NACH_DURCHGANG_2;
			showActual();
			break;
		case SkispringenGUI.ENDPLATZIERUNG_NACH_DURCHGANG_2:
			// nix machen!
		}
	}

	private void showActual() {
		this.anzeige.setText(nameDerPhase() + "\n" + "\n"
				+ actuelleListe().toString("\n") + sieger());
	}

	private String sieger() {
		if (phase == SkispringenGUI.ENDPLATZIERUNG_NACH_DURCHGANG_2) {
			this.dieSimulation.getSiegerliste().toFirst();
			return "\n\n" + "Der Sieger des Wettbewerbs ist \n"
					+ this.dieSimulation.getSiegerliste().getContent();
		} else {
			return "";
		}
	}

	private Teilnehmerliste actuelleListe() {
		switch (this.phase) {
		case SkispringenGUI.VOR_WETTBEWERB:
			return this.dieSimulation.getAlleSpringer();
		case SkispringenGUI.REIHENFOLGE_NACH_DURCHGANG_1:
			return this.dieSimulation.getRanglisteNachErstemDurchgang();
		case SkispringenGUI.AUSSORTIEREN_DER_SCHLECHTESTEN:
			return this.dieSimulation.getTeilnehmerVorZweitemDurchgang();
		case SkispringenGUI.STARTREIHENFOLGE_VOR_DURCHGANG_2:
			return this.dieSimulation.getStartlisteZweiterDurchgang();
		case SkispringenGUI.ENDPLATZIERUNG_NACH_DURCHGANG_2:
			return this.dieSimulation.getSiegerliste();
		default:
			return null;

		}
	}

	private String nameDerPhase() {
		switch (this.phase) {
		case SkispringenGUI.VOR_WETTBEWERB:
			return "Der Wettbewerb startet!";
		case SkispringenGUI.REIHENFOLGE_NACH_DURCHGANG_1:
			return "Der erste Durchgang hat stattgefunden!";
		case SkispringenGUI.AUSSORTIEREN_DER_SCHLECHTESTEN:
			return "Die Besten bleiben!";
		case SkispringenGUI.STARTREIHENFOLGE_VOR_DURCHGANG_2:
			return "Die Reihenfolge fr den zweiten Durchgang!";
		case SkispringenGUI.ENDPLATZIERUNG_NACH_DURCHGANG_2:
			return "Das Springen ist beendet!";
		default:
			return "";

		}
	}
}
